//subdivide polygon shit goes here

#include <xsi_application.h>
#include <xsi_context.h>
#include <xsi_math.h>
#include <xsi_edge.h>

#include <xsi_argument.h>
#include <xsi_toolcontext.h>
#include <xsi_menu.h>
#include <xsi_menuitem.h>
#include <xsi_segment.h>
#include <xsi_siobject.h>
#include <xsi_point.h>
#include <xsi_edge.h>
#include <xsi_comapihandler.h>
#include <xsi_polygonface.h>
#include <xsi_vertex.h>


#include <xsi_selection.h>
#include <xsi_polygonmesh.h>
#include <xsi_primitive.h>
#include <xsi_geometryaccessor.h>
#include <list>
#include <vector>

using namespace XSI; 
using namespace XSI::MATH; 

#include "subdivide.h"
void logv(CString in_str, CValue in){
	Application().LogMessage(in_str + L" " + CString(in));
}

CVector3 edgeMidPoint(Edge edge)
{
	CVector3 p;
	CVertexRefArray	edgeVerts( edge.GetVertices() );
	Vertex	 v1 = edgeVerts[0], 
			v2 = edgeVerts[1];
	p = v1.GetPosition();
	p += v2.GetPosition();
	p *= 0.5;
	return p;
}

CVector3 catmullFacePoint(PolygonFace &in_face) //catmull-clark edge point
{
	CVector3 facepoint;
	CVertexRefArray faceverts( in_face.GetVertices() );
	for (int j=0;j< faceverts.GetCount();j++) //add face vertexpos to array
	{
		Vertex v(faceverts[j] );
		facepoint += v.GetPosition();
	}
	facepoint *= (1.0/faceverts.GetCount());
	return facepoint;
}

CVector3 catmullEdgePoint(Edge &in_edge, bool boundaryCheck)	//catmull-clark facepoint
{	
	CPolygonFaceRefArray edgeFaces( in_edge.GetNeighborPolygons() );
	CVertexRefArray		 edgeVerts( in_edge.GetVertices() );
	Vertex v1 = edgeVerts[0], v2 = edgeVerts[1];
	CVector3 p,p2,p3;

	double crease = in_edge.GetCrease();
	if (crease > 1.0) crease = 1.0;
	double crease_invers = 1.0 - crease;
	
	p3 = v1.GetPosition();
	p3 += v2.GetPosition();
	p3 *= 0.5;	

	if (in_edge.GetIsBoundary() && boundaryCheck)
	{
		return p3;
	}

	for (int i=0;i<edgeFaces.GetCount(); i++)
	{
		PolygonFace		face(edgeFaces[i]);
		p+= catmullFacePoint(face);
	}
	p*=0.5;
	
	
	p2 = v1.GetPosition();
	p2+= v2.GetPosition();
	p2 *= 0.5;
	p += p2;
	p *= 0.5;

	p*=crease_invers;

	p3*=crease;
	p+=p3;	

	return p;

}

CVector3 catmullVertexPoint(Vertex &in_v)
{
	CVector3 v(in_v.GetPosition()),
		Q(0,0,0),
		R(0,0,0);

	double n;
	double crease = in_v.GetCrease();
	if (crease > 1.0) crease = 1.0;
	double crease_invers = 1.0 - crease;

	CPolygonFaceRefArray &vertFaces(in_v.GetNeighborPolygons() );
	CEdgeRefArray		 &vertEdges(in_v.GetNeighborEdges() );

	double vertFaceCnt = vertFaces.GetCount();
	double vertEdgeCnt = vertEdges.GetCount();

	bool infinitesharp = true;			// check if vertex has non interior edges = infinite sharp vertex.
	int bsharpedgcnt = 0;
	for (int i=0;i<vertEdges.GetCount();i++)
	{
		Edge e(vertEdges[i]);
		if (!e.GetIsBoundary())
		{
			infinitesharp = false;
			
		}else bsharpedgcnt++;
	}
	if (infinitesharp || bsharpedgcnt >3)
		return v;

	if (in_v.GetIsBoundary())	//boundary vert. Calc as sum of vert's original pos *6/8 + neighbor verts pos on <boundary curve> *1/6
	{
		CVector3 borderCatmullpoint = in_v.GetPosition();

		borderCatmullpoint *= (6.0/8.0);

		for(int i =0;i<vertEdges.GetCount();i++)
		{
			Edge e(vertEdges[i]);
			if (e.GetIsBoundary()) //take boundary edge
			{
				CVertexRefArray v_nev(e.GetVertices());
				for (int j=0;j< v_nev.GetCount();j++)  
				{
					Vertex ve(v_nev[j]);
					if (ve.GetIsBoundary() )
					if (ve.GetIndex() != in_v.GetIndex()) //not original vertex
					{
						CVector3 t = ve.GetPosition();

						t*=(1.0/8.0);
						
						borderCatmullpoint+=t;
					}
				}
			}
		}
		borderCatmullpoint*=crease_invers;
		CVector3 t = in_v.GetPosition();
		t*=crease;
		borderCatmullpoint+=t;
		return borderCatmullpoint;
	}		// end if is boundary

	for (int i=0;i<vertEdgeCnt; i++)		//averange of all mid points of in_v
	{
		R+= edgeMidPoint(vertEdges[i]);
	}

	R *= (double)(1.0/vertEdgeCnt);
	

	for (int i=0;i<vertFaceCnt; i++)		//averange of all new faces points of in_v
	{
		Q+= catmullFacePoint((PolygonFace)vertFaces[i]);
	}

	Q *= (double)(1.0/vertFaceCnt);
	
	n = 1/vertEdgeCnt;
	R *= 2.0;
	
	v *= (vertEdgeCnt - 3.0);

	
	v += Q;	v += R;

	v *= n;

	v*=crease_invers;
	CVector3 t = in_v.GetPosition();
	t*=crease;
	v+=t;

	return v;
}

CVector3Array subdivideEdge(Edge in_edge, int in_approxLevel)	//not used
{
		CVector3Array	edgepts;
		CVector3Array	edgepts2;//for valence 2 case
		CVertexRefArray	edgeVerts( in_edge.GetVertices() );
		
		
		for (int i=0;i<2;i++)
		{
			Vertex v = edgeVerts[i];
			CEdgeRefArray	vertEdges( v.GetNeighborEdges() );
			if (vertEdges.GetCount() == 2)	//point with valence 2, dont add to triangle data
			{
				if ( v.GetIsBoundary() )	//boundary valence 2 points allowed
					edgepts2.Add(catmullVertexPoint(v));
				else
				{
					double crease = v.GetCrease();
					if (crease > 1.0) crease = 1.0;
					double crease_invers = 1.0 - crease;
					CVector3Array edgemid;
					
					edgemid.Add(catmullEdgePoint((Edge)vertEdges[0],true));
					edgemid.Add(catmullEdgePoint((Edge)vertEdges[1],true));
					CVector3 edgept = edgemid[0];
					edgept += edgemid[1];
					edgept *= 0.5;
					CVector3 v_c(v.GetPosition());
					v_c	*= crease;
					edgept *= crease_invers;
					edgept += v_c;
					edgepts2.Add(edgept);
				}
			} 
			else 
				edgepts2.Add(catmullVertexPoint(v));
		}
		edgepts.Add(edgepts2[0]);
		edgepts.Add(catmullEdgePoint(in_edge,true));			
		edgepts.Add(edgepts2[1]);
	
		return edgepts;
};

CVector3 subdividePoint(Vertex in_v, int in_approxLevel)
{
	CVector3 v;
	Vertex vert = in_v;

	CEdgeRefArray	vertEdges( vert.GetNeighborEdges() );

	if (vertEdges.GetCount() == 2)	//point with valence 2, dont add to triangle data
	{
		if ( vert.GetIsBoundary() && in_v.GetCrease()==0)	//boundary valence 2 points allowed
			v = catmullVertexPoint(vert);
		else
		{
			double crease = in_v.GetCrease();
			if (crease > 1.0) crease = 1.0;
			double crease_invers = 1.0 - crease;
			CVector3Array edgemid;
			edgemid.Add(catmullEdgePoint((Edge)vertEdges[0],true));
			edgemid.Add(catmullEdgePoint((Edge)vertEdges[1],true));
			CVector3 edgept = edgemid[0];
			edgept += edgemid[1];
			edgept *= 0.5;

			CVector3 v_c(in_v.GetPosition());
			v_c	*= crease;
			edgept *= crease_invers;
			v = edgept;
			v+= v_c;
		}
	} 
	else 
		v = catmullVertexPoint(vert);
	//v = catmullVertexPoint(vert);
	vert.PutPosition(v);
	
	return v;
}

CVector3Array subdivideFace(PolygonFace &in_poly,int in_approxLevel)
{
	CVector3Array	polypts;

	CVertexRefArray	polyVerts( in_poly.GetVertices() );
	CEdgeRefArray	polyEdges( in_poly.GetEdges() );

	CVector3 facepoint = catmullFacePoint(in_poly);

	polypts.Add(facepoint);

	for (int i=0;i<polyEdges.GetCount();i++)
	{
		Edge	polyEdge(polyEdges[i]);
		Vertex v = polyVerts[i];

		CEdgeRefArray	vertEdges( v.GetNeighborEdges() );
		if (vertEdges.GetCount() == 2)	//point with valence 2, dont add to triangle data
		{
			if ( v.GetIsBoundary() && v.GetCrease()==0 )	//boundary valence 2 points allowed
				polypts.Add(catmullVertexPoint(v));	
			else
				{
					double crease = v.GetCrease();
					if (crease > 1.0) crease = 1.0;
					double crease_invers = 1.0 - crease;
					CVector3Array edgemid;
					
					edgemid.Add(catmullEdgePoint((Edge)vertEdges[0],true));
					edgemid.Add(catmullEdgePoint((Edge)vertEdges[1],true));
					CVector3 edgept = edgemid[0];
					edgept += edgemid[1];
					edgept *= 0.5;
					CVector3 v_c(v.GetPosition());
					v_c	*= crease;
					edgept *= crease_invers;
					edgept += v_c;
					polypts.Add(edgept);	
				}
		} 
		else 
			polypts.Add(catmullVertexPoint(v));	
		polypts.Add(catmullEdgePoint(polyEdge,true));	
	}

	return polypts;
}